package com.kasetoatz.hungryfrog.item;

import net.minecraft.entity.EntityType;
import net.minecraft.entity.SpawnReason;
import net.minecraft.entity.passive.FrogEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.Item;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.hit.HitResult;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

public class FrogInfestationItem extends Item {
    public FrogInfestationItem(Settings settings) {
        super(settings);
    }

    public ActionResult use(World world, PlayerEntity user, Hand hand)
    {
        HitResult hit = user.raycast(1000, 1.F, true);
        if (hit.getType() == HitResult.Type.BLOCK)
        {
            Vec3d pos = hit.getPos().add(0.F, 1.F, 0.F);
            for (int i = 0; i < 100; i++)
            {
                FrogEntity frog = EntityType.FROG.create(world, SpawnReason.MOB_SUMMONED);
                if (frog != null)
                {
                    frog.setPos(pos.getX(), pos.getY(), pos.getZ());
                    world.spawnEntity(frog);
                }
            }
        }
        return ActionResult.SUCCESS;
    }
}
