package com.kasetoatz.hungryfrog.mixin;

import com.kasetoatz.hungryfrog.HungryFrog;
import com.kasetoatz.hungryfrog.sensor.NearestBlockSensor;
import com.kasetoatz.hungryfrog.task.FrogEatBlockTask;
import net.minecraft.entity.ai.brain.Activity;
import net.minecraft.entity.ai.brain.Brain;
import net.minecraft.entity.passive.FrogBrain;
import net.minecraft.entity.passive.FrogEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import java.util.HashMap;
import java.util.LinkedHashSet;

@Mixin(FrogBrain.class)
public class FrogBrainMixin
{
    @Inject(method = "create", at = @At("RETURN"), cancellable = true)
    private static void create(Brain<FrogEntity> brain, CallbackInfoReturnable<Brain<?>> cir)
    {
        Brain<?> frog = cir.getReturnValue();
        @SuppressWarnings("unchecked")
        BrainAccessor<FrogEntity> accessor = (BrainAccessor<FrogEntity>) frog;
        accessor.getSensors().put(HungryFrog.NEAREST_BLOCK_SENSOR, new NearestBlockSensor());
        accessor.getTasks().computeIfAbsent(1, p -> new HashMap<>()).computeIfAbsent(Activity.IDLE, a -> new LinkedHashSet<>()).add(new FrogEatBlockTask());
        cir.setReturnValue(frog);
    }
}
